//RaGrid 
#define GA_ALIGN_LEFT 	0
#define GA_ALIGN_CENTER	1
#define GA_ALIGN_RIGHT	2
#define TYPE_EDITTEXT      0              //String
#define TYPE_EDITLONG      1              //Long
#define TYPE_CHECKBOX      2              //Long
#define TYPE_COMBOBOX      3              //Long
#define TYPE_HOTKEY            4              //Long
#define TYPE_BUTTON            5              //String
#define TYPE_IMAGE             6              //Long
#define TYPE_DATE              7              //Long
#define TYPE_TIME              8              //Long
#define TYPE_USER              9              //0=String, 1 to 512 bytes binary data
#define TYPE_EDITBUTTON        10                 //String


class cApp 
{
	public:
		void set_callback(WNDPROC param);
		WNDPROC get_callback();
		long MsgLoop();
	private:
	  WNDPROC CallBackProc;
	  HWND GetFormHandle(HWND hwnd);
};
WNDPROC cApp::get_callback()
{
	return CallBackProc;
}

void cApp::set_callback(WNDPROC param)
{
	CallBackProc = param;
}
// I believe I lifted the Pb Version from Dominic 
long cApp::MsgLoop()
{
	HWND hWndModeless;
	MSG msg;

	while (GetMessage(&msg,NULL,0,0))
	{
		hWndModeless = GetFormHandle(GetFocus());
		if((hWndModeless==NULL) | (IsDialogMessage(hWndModeless, &msg) == 0))
		{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		}
	}
	return msg.wParam;

}

HWND cApp::GetFormHandle(HWND hWnd)
{
	while (GetWindowLong(hWnd,GWL_STYLE) & WS_CHILD)
		{
			if(GetWindowLong(hWnd,GWL_EXSTYLE) & WS_EX_MDICHILD)
			break;
			hWnd=GetParent(hWnd);	
		}
	return hWnd;
}

static const CLSID CLSID_CCONTROL  = {0x168d6f1a,0xba2,0x4f6f,{0xb4,0x46,0xfb,0xea,0x87,0xd,0x23,0x87}};
static const CLSID CLSID_CWINDOW  = {0xca077f05,0xc904,0x4f44,{0xb8,0xed,0x84,0x8e,0xca,0xc7,0x13,0x6f}};
static const CLSID CLSID_CTABCONTROL  = {0x531ff619,0x7598,0x4311,{0xb6,0xdb,0x25,0x28,0xaa,0xd5,0xbb,0xd2}};
static const CLSID CLSID_CDISPLAYOPENFILE  = {0xd11bd78,0xa2d3,0x4295,{0x96,0x74,0xba,0xd2,0xbe,0xd5,0x6b,0xcd}};
static const CLSID CLSID_CGRIDCOL  = {0x8ea5fbd0,0x8fe2,0x4793,{0xbf,0xf2,0x23,0x0,0x4f,0xb4,0xdc,0x26}};
static const CLSID CLSID_CRAGRID  = {0x51fa57c3,0x5b52,0x4032,{0xab,0xe9,0x1d,0xe6,0xc9,0x30,0x3b,0x89}};

static const IID IID_ICONTROL  = {0xdc54ca96,0x58a9,0x4149,{0xb9,0x84,0x19,0x1b,0xf,0x74,0x3d,0xec}};
static const IID IID_IWINDOW  = {0x4fc3103b,0xaac8,0x4ddd,{0x9a,0xa5,0x6f,0x3,0x80,0xc4,0x37,0xf6}};
static const IID IID_ITABCONTROL  = {0xee878375,0xb49a,0x498e,{0x95,0xd8,0xd8,0x79,0xa9,0xec,0x8c,0x3f}};
static const IID IID_IDISPLAYOPENFILE  = {0xeccb7638,0x95a9,0x4479,{0xa2,0x77,0x1b,0x45,0xdc,0x76,0x3c,0xff}};
static const IID IID_IGRIDCOL  = {0x2c1dec9b,0x47b9,0x47c3,{0x93,0x52,0x4e,0x9c,0x5d,0xe4,0xfb,0x45}};
static const IID IID_IRAGRID  = {0x89e45f6b,0x6a82,0x4fab,{0xa5,0x93,0xef,0x9,0x37,0xe8,0x1d,0xf3}};


interface iGridCol : IUnknown
{
virtual void    __stdcall set_Width(long);
virtual void    __stdcall set_HeaderText(BSTR);
virtual void    __stdcall set_HeaderAlign(long);
virtual void    __stdcall set_ColAlign(long);
virtual void    __stdcall set_ColDataType(long);
virtual void    __stdcall set_TextMax(long);
virtual void    __stdcall set_FormatStr(BSTR);
virtual void    __stdcall set_hImageList(long);
virtual void    __stdcall set_HeaderFlags(long);
virtual DWORD    __stdcall get_ColInfo();
};
//----------------------------------------------------
interface iRaGrid : IUnknown
{
virtual void    __stdcall set_hCtl(HWND);
virtual void    __stdcall set_BackColor(long);
virtual void    __stdcall set_GridColor(long);
virtual void    __stdcall set_TextColor(long);
virtual void    __stdcall set_HeaderHeight(long);
virtual void    __stdcall AddColumn(DWORD);
virtual long    __stdcall AddRowData(BSTR);
virtual long    __stdcall AddComboData(long,BSTR);
virtual BSTR    __stdcall GetColRowStringData(long,long);
virtual BSTR    __stdcall GetCurrentCellStringData();
};



interface iDisplayOpenFile : IUnknown
{
virtual void    __stdcall set_Folder(BSTR);
virtual void    __stdcall set_Filter(BSTR);
virtual void    __stdcall set_Parent(HWND);
virtual void    __stdcall set_DlfExt(BSTR);
virtual void    __stdcall set_Start(BSTR);
virtual void    __stdcall set_Title(BSTR);
virtual void    __stdcall set_Flags(DWORD);
virtual BSTR    __stdcall GetName();
};

interface iTabControl : IUnknown
{
virtual void    __stdcall PrintIt();
virtual HWND    __stdcall get_hCtl();
virtual void    __stdcall set_hCtl(HWND);
virtual long    __stdcall GetCurFocus();
virtual long    __stdcall GetCurSel();
virtual long    __stdcall GetItemCount();
virtual long    __stdcall GetItemRect(long,DWORD);
virtual long    __stdcall GetRowCount();
virtual DWORD    __stdcall GetToolTips();
virtual void    __stdcall AdjustRect(long,DWORD);
virtual long    __stdcall DeleteAllItems();
virtual long    __stdcall DeleteItem(long);
virtual long    __stdcall GetItem(long,DWORD);
virtual long    __stdcall AddTab(BSTR);
virtual void    __stdcall RemoveImage(long);
virtual long    __stdcall SetCurSel(long);
virtual DWORD    __stdcall get_hImageList();
virtual void    __stdcall set_hImageList(DWORD);
virtual long    __stdcall SetItem(long,DWORD);
virtual long    __stdcall SetItemSize(short,short);
virtual long    __stdcall SetPadding(short,short);
virtual void    __stdcall AddTabPage(HWND);
virtual void    __stdcall ShowPage(long);
virtual void    __stdcall HidePage(long);
};




interface iControl : IUnknown
{
virtual BSTR    __stdcall get_List();
virtual void    __stdcall set_List(BSTR);
virtual BSTR    __stdcall get_StatusParts();
virtual void    __stdcall set_StatusParts(BSTR);
virtual void    __stdcall set_TextAlign(BSTR);
virtual BSTR    __stdcall get_Name();
virtual void    __stdcall set_Name(BSTR);
virtual long    __stdcall get_Id();
virtual void    __stdcall set_Id(long);
virtual long    __stdcall get_Top();
virtual void    __stdcall set_Top(long);
virtual long    __stdcall get_Left();
virtual void    __stdcall set_Left(long);
virtual long    __stdcall get_Width();
virtual void    __stdcall set_Width(long);
virtual long    __stdcall get_Height();
virtual void    __stdcall set_Height(long);
virtual DWORD    __stdcall get_Style();
virtual void    __stdcall set_Style(DWORD);
virtual DWORD    __stdcall get_ExStyle();
virtual void    __stdcall set_ExStyle(DWORD);
virtual HWND    __stdcall get_Parent();
virtual void    __stdcall set_Parent(HWND);
virtual BSTR    __stdcall get_Text();
virtual void    __stdcall set_Text(BSTR);
virtual HWND    __stdcall get_Handle();
virtual void    __stdcall set_Handle(HWND);
virtual BSTR    __stdcall get_Class();
virtual void    __stdcall set_Class(BSTR);
virtual DWORD    __stdcall get_hInst();
virtual void    __stdcall set_hInst(DWORD);
virtual long    __stdcall get_BackColor();
virtual void    __stdcall set_BackColor(long);
virtual DWORD    __stdcall get_hBkBrush();
virtual long    __stdcall get_ForeColor();
virtual void    __stdcall set_ForeColor(long);
virtual HFONT    __stdcall get_Font();
virtual void    __stdcall set_Font(HFONT);
virtual iRaGrid*	__stdcall get_oRaGrid();
virtual iTabControl* __stdcall get_oTab();
virtual DWORD    __stdcall CreateControl();
};
//----------------------------------------------------
interface iWindow : IUnknown
{
virtual HWND    __stdcall CreateWin();
virtual long    __stdcall CreateChildWin();
virtual long    __stdcall get_Id();
virtual void    __stdcall set_Id(long);
virtual WNDPROC    __stdcall get_CallBackProc();
virtual void    __stdcall set_CallBackProc(WNDPROC);
virtual long    __stdcall get_Top();
virtual void    __stdcall set_Top(long);
virtual long    __stdcall get_Left();
virtual void    __stdcall set_Left(long);
virtual long    __stdcall get_Width();
virtual void    __stdcall set_Width(long);
virtual long    __stdcall get_Height();
virtual void    __stdcall set_Height(long);
virtual DWORD    __stdcall get_Style();
virtual void    __stdcall set_Style(DWORD);
virtual DWORD    __stdcall get_ExStyle();
virtual void    __stdcall set_ExStyle(DWORD);
virtual long    __stdcall get_BackColor();
virtual void    __stdcall set_BackColor(long);
virtual HWND    __stdcall get_Parent();
virtual void    __stdcall set_Parent(HWND);
virtual HWND    __stdcall get_Handle();
virtual void    __stdcall set_Handle(HWND);
virtual BSTR    __stdcall get_Title();
virtual void    __stdcall set_Title(BSTR);
virtual HFONT    __stdcall MakeFont(BSTR,long,long);
virtual void    __stdcall HSpaceControls(HWND,long[],long);
virtual long	__stdcall WmCtlColor(HDC,HWND);
};
//----------------------------------------------------
